/**********************************************************
*                                                         *
* (c) 2008 - 2014 LnK                                     *
*                                                         *
* LnKSLIMbusBridge_IF.h									  *
* Version 1.7                                             *
*                                                         *
* Header file for LnKSLIMbusBridge_IF DLL                 *
*                                                         *
* Date 4 Jan 2014                                         *
*                                                         *
* Johan Klewais                                           *
*                                                         *
* www.lnk-tools.com - info@lnk-tools.com                  *
*                                                         *
**********************************************************/
#ifdef CONSOLETEST_EXPORT
    #define MY_API __declspec(dllexport)
#else
    #define MY_API __declspec(dllimport)
#endif


#define ERROR_WRONG_VE_LENGTH			-1	
#define ERROR_RX_MESSAGE_TIMEOUT		-2
#define ERROR_WRONG_REPLY_LENGTH		-3
#define ERROR_WRONG_MESSAGE				-4



extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeOpen(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeClose(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( char manager, char sniffer, char framer );
extern "C" __declspec(dllexport) void _stdcall LnKSLIMbusDirectControlBridgeFlushRx( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeDoEnumBridge( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeTxMessage( char * txmes, int len );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeRxMessage( char * rxmes );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgePollRx( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeGetDLLVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDirectControlBridgeRequestVE( unsigned char la, unsigned long address, unsigned long len, unsigned long timeout_ms );




