// TestLnKSLIMbusDirectControlBridgeAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestLnKSLIMbusDirectControlBridgeApp.h"
#include "TestLnKSLIMbusDirectControlBridgeAppDlg.h"
#include "LnKSLIMbusDirectControlBridge_IF.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char g_framer;
char g_sniffer;
char g_manager;
char g_rxmes[512];


#define RX_CTRL_CMD		1
#define RX_MES_CMD		2
#define RX_ERROR_CMD	3
#define RX_ACK_CMD		4
#define RX_OVER_CMD		5



// F2FF0A021501C10001020002F0  // ASSIGN_LOGICAL_ADDRESS(Dst=0x01C100010200, LA=0x02)
char  ALA0200[] = {
	0xF2, 0xFF, 0x0A, 0x02, 0x15, 0x01, 0xC1, 0x00, 0x01, 0x02, 0x00, 0x02, 0xF0
};

// F2FF0A021501C1000101000100  // ASSIGN_LOGICAL_ADDRESS(Dst=0x01C100010100, LA=0x01)
char  ALA0100[] = {
	0xF2, 0xFF, 0x0A, 0x02, 0x15, 0x01, 0xC1, 0x00, 0x01, 0x01, 0x00, 0x01, 0x00
};
// F2FF0A021501C1000100000050  // ASSIGN_LOGICAL_ADDRESS(Dst=0x01C100010000, LA=0x00)
char  ALA0000[] = {
	0xF2, 0xFF, 0x0A, 0x02, 0x15, 0x01, 0xC1, 0x00, 0x01, 0x00, 0x00, 0x00, 0x50
};

//F2FF0760010200080080  // REQUEST_VALUE(Src=0xFF, Dst=0x02, TID=0, AM=1, BA=0x000, SS=0)
char RVE0[] = {
	0xF2, 0xFF, 0x07, 0x60, 0x01, 0x02, 0x00, 0x08, 0x00, 0x80
};

//F2FF07600102011800C0  // REQUEST_VALUE(Src=0xFF, Dst=0x02, TID=1, AM=1, BA=0x001, SS=0)


//F2FF0760010202280000  // REQUEST_VALUE(Src=0xFF, Dst=0x02, TID=2, AM=1, BA=0x002, SS=0)

//F2FF03403100  // BEGIN_RECONFIGURATION()
char BC[] = {
	0xF2, 0xFF, 0x03, 0x40, 0x31, 0x00
};
//F2FF0447370130  // - NEXT_ROOT_FREQUENCY(RF=1)
char NRF[] = {
	0xF2, 0xFF, 0x04, 0x47, 0x37, 0x01, 0x30
};
//F2FF0446320980  // - NEXT_CLOCK_GEAR(CG=9)
char NCG[] = {
	0xF2, 0xFF, 0x04, 0x46, 0x32, 0x09, 0x80
};
//F2FF035F3800  // RECONFIGURE_NOW()
char RN[] = {
	0xF2, 0xFF, 0x03, 0x5F, 0x38, 0x00
};






/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKSLIMbusDirectControlBridgeAppDlg dialog

CTestLnKSLIMbusDirectControlBridgeAppDlg::CTestLnKSLIMbusDirectControlBridgeAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestLnKSLIMbusDirectControlBridgeAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestLnKSLIMbusDirectControlBridgeAppDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestLnKSLIMbusDirectControlBridgeAppDlg)
	DDX_Control(pDX, IDC_EDIT_VE_LA, m_LA);
	DDX_Control(pDX, IDC_EDIT_VE_SIZE, m_VeSize);
	DDX_Control(pDX, IDC_EDIT_VE_RESULT, m_VeResult);
	DDX_Control(pDX, IDC_EDIT_VE_ADDRESS, m_VeAddress);
	DDX_Control(pDX, IDC_EDIT_TX_MES, m_TxMes);
	DDX_Control(pDX, IDC_EDIT_RX_MES, m_RxMes);
	DDX_Control(pDX, IDC_CHECK_SNIFFER, m_SnifferCB);
	DDX_Control(pDX, IDC_CHECK_MANAGER, m_ManagerCB);
	DDX_Control(pDX, IDC_CHECK_FRAMER, m_FramerCB);
	DDX_Control(pDX, IDC_LOG, m_Log);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestLnKSLIMbusDirectControlBridgeAppDlg, CDialog)
	//{{AFX_MSG_MAP(CTestLnKSLIMbusDirectControlBridgeAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_START_MANAGER, OnButtonStartManager)
	ON_BN_CLICKED(IDC_BUTTON_START_FRAMER, OnButtonStartFramer)
	ON_BN_CLICKED(IDC_BUTTON_STOP_FRAMER, OnButtonStopFramer)
	ON_BN_CLICKED(IDC_BUTTON_STOP_MANAGER, OnButtonStopManager)
	ON_BN_CLICKED(IDC_BUTTON_START_GRABBER, OnButtonStartGrabber)
	ON_BN_CLICKED(IDC_BUTTON_STOP_GRABBER, OnButtonStopGrabber)
	ON_BN_CLICKED(IDC_BUTTON_ENUMERATE_BRIDGE, OnButtonEnumerateBridge)
	ON_BN_CLICKED(IDC_BUTTON_REQUEST_VE, OnButtonRequestVe)
	ON_BN_CLICKED(IDC_BUTTON_READ_MESSAGE, OnButtonReadMessage)
	ON_BN_CLICKED(IDC_BUTTONTX_MESSAGE, OnButtontxMessage)
	ON_BN_CLICKED(IDC_BUTTON_TX_RX, OnButtonTxRx)
	ON_BN_CLICKED(IDC_BUTTON_TX_RX_1000, OnButtonTxRx1000)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKSLIMbusDirectControlBridgeAppDlg message handlers

BOOL CTestLnKSLIMbusDirectControlBridgeAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestLnKSLIMbusDirectControlBridgeAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


unsigned long CTestLnKSLIMbusDirectControlBridgeAppDlg::str232( char * ptr )
{
	unsigned long val = 0;
	unsigned long mul = 10;


	if( ptr[0] == '0' && (ptr[1] == 'x' || ptr[1] == 'X'))
	{
		ptr += 2;
		mul = 0x10;
	}
	while( *ptr != 0 )
	{
		if( *(ptr) >= '0' && *(ptr) <= '9' )
		{
			val *= mul;
			val += (*(ptr) - '0');
			ptr++;
		}
		else if( *(ptr) >= 'a' && *(ptr) <= 'f' )
		{
			val *= mul;
			val += (*(ptr) - 'a' + 10) ;
			ptr++;
		}
		else if( *(ptr) >= 'A' && *(ptr) <= 'F' )
		{
			val *= mul;
			val += (*(ptr) - 'A' + 10) ;
			ptr++;
		}
		else
			break;
	}
	return(val);
}

unsigned long	CTestLnKSLIMbusDirectControlBridgeAppDlg::String2Hex(char * SrcPtr, char * HexBufPtr)
{
	char *			ulValPtr;
	unsigned long	cnt = 0;


	ulValPtr = strstr( SrcPtr,"0x" );	
	do {
		if( ulValPtr )
		{
			HexBufPtr[cnt] = (char) str232( ulValPtr );

			cnt++;
			ulValPtr = strstr( ulValPtr+1,"0x" );	
		}
		else
			break;

		} while (cnt <= 28);
	return(cnt);
}


void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonOpen() 
{
	int		status;
	char	buf[256];

	status = LnKSLIMbusDirectControlBridgeOpen();

	sprintf( buf,"Open = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	g_framer	= 0;
	g_sniffer	= 0;
	g_manager	= 0;

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);

	m_TxMes.SetWindowText("0xF2 0xFF 0x07 0x60 0x01 0x02 0x00 0x08 0x00 0x80");

}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonClose() 
{
	int		status;
	char	buf[256];

	status = LnKSLIMbusDirectControlBridgeClose();
	sprintf( buf,"Close = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
}


void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStartFramer() 
{
	int	status = 0;
	char	buf[256];
	
	g_framer = 1;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"START FRAMER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);
}


void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStopFramer() 
{
	int	status = 0;
	char	buf[256];
	
	g_framer = 0;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"STOP FRAMER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStartManager() 
{
	int	status = 0;
	char	buf[256];
	
	g_manager = 1;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"START MANAGER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStopManager() 
{
	int	status = 0;
	char	buf[256];
	
	g_manager = 0;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"STOP MANAGER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStartGrabber() 
{
	int	status = 0;
	char	buf[256];
	
	g_sniffer = 1;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"START SNIFFER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonStopGrabber() 
{
	int	status = 0;
	char	buf[256];
	
	g_sniffer = 0;
	status = LnKSLIMbusDirectControlBridgeEnableMasterSnifferFramer( g_manager, g_sniffer, g_framer );
	sprintf( buf,"STOP SNIFFER - EnableMasterSnifferFramer = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	

	m_SnifferCB.SetCheck(g_sniffer);
	m_FramerCB.SetCheck(g_framer);
	m_ManagerCB.SetCheck(g_manager);	
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonEnumerateBridge() 
{
	char			buf[512];
	int				status = 0;

	// do the enumeration of the AudioBridge when it has not been done by another user
	status = LnKSLIMbusDirectControlBridgeDoEnumBridge(  );

	sprintf( buf,"LnKSLIMbusDirectControlBridgeDoEnumBridge = %d", status );
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonReadMessage() 
{
	char			buf[512];	

	int				status = 0;
	int				len;
	int				a;


	status = LnKSLIMbusDirectControlBridgePollRx();
	switch( status  )
	{
	case RX_CTRL_CMD:
		sprintf( buf,"OnButtonRequestVe  RX_CTRL_CMD = 0x%02x"
			, status 			
			);
		break;

	case RX_MES_CMD:
		{
			status = LnKSLIMbusDirectControlBridgeRxMessage( g_rxmes );		
			if( status > 0 )
			{
				for( a = 0; a < status; a++ )
				{
					sprintf( buf + (3*a),"%02x ",  (unsigned char) g_rxmes[a] );
				}
				m_RxMes.SetWindowText(buf);
				m_RxMes.UpdateWindow();
			}
			else
			{
				m_RxMes.SetWindowText("");
				m_RxMes.UpdateWindow();
			}
		}
		break;

	case RX_ERROR_CMD:
		sprintf( buf,"OnButtonRequestVe  RX_ERROR_CMD = 0x%02x "
			, status 			
			);
		break;

	case RX_OVER_CMD:
		sprintf( buf,"OnButtonRequestVe  RX_OVER_CMD = 0x%02x "
			, status 			
			);
		break;

	case 0:
		sprintf( buf,"OnButtonRequestVe  - "
			, status 			
			);
		break;

	default:
		sprintf( buf,"OnButtonRequestVe  ?? 0x%02x "
			, status 			
			);
		break;
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();


}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtontxMessage() 
{
	char			buf[512];	
	char			binbuf[256];
	int				status = 0;
	CString			ValString;
	int				len;

	// retriev the hex TX message
	m_TxMes.GetWindowText( ValString );
	sprintf( buf, "%s", ValString);

	// translate the hex text to binary ( "0x12 0x34 .. " to binary 12,34 ..)
	len = String2Hex(buf, binbuf );

	// call the DLL function to transmit this message on the SLIMbus via the LnK AudioBridge
	status = LnKSLIMbusDirectControlBridgeTxMessage(binbuf, len);

	sprintf( buf,"tx message status = %d", status );
	m_Log.SetWindowText(buf);
}




void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonTxRx() 
{
	OnButtontxMessage();			// send message
	OnButtonReadMessage();			// receive the echo of the TX message
	OnButtonReadMessage();			// receive the REPLY_VALUE message
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonTxRx1000() 
{
	int	a;

	for(a = 0; a < 1000; a++ )
	{
		OnButtontxMessage();		// send message
		OnButtonReadMessage();		// receive the echo of the TX message
		OnButtonReadMessage();		// receive the REPLY_VALUE message
	}
	
}

void CTestLnKSLIMbusDirectControlBridgeAppDlg::OnButtonRequestVe() 
{
	char			buf[512];	
	char			binbuf[512];
	int				status = 0;
	CString			ValString;
	int				len;
	unsigned long	VeAddress, VeSize;
	unsigned long	EC;
	unsigned char	LA;

	// read Logical Address
	m_LA.GetWindowText( ValString );
	sprintf( buf, "%s", ValString);
	LA = str232( buf );

	// read Address of the requested Value Element
	m_VeAddress.GetWindowText( ValString );
	sprintf( buf, "%s", ValString);
	VeAddress = str232( buf );

	// read the size of the requested Value Element in bytes)
	m_VeSize.GetWindowText( ValString );
	sprintf( buf, "%s", ValString);
	VeSize = str232( buf );


	// call the function in the DLL to execute the REQUEST_VALUE and wait for the REPLY_VALUE over the SLIMbus via the LnK AudioBridge
	status = LnKSLIMbusDirectControlBridgeRequestVE( LA/*la*/, VeAddress, VeSize, 100 /* timeout in ms */ );

	if( status >= 0 ) // status contains the number of received bytes
	{
		sprintf( buf,"0x%02x", status );
		m_VeResult.SetWindowText(buf);
		m_VeResult.UpdateWindow();

		sprintf( buf,"OnButtonRequestVe  status = 0x%02x", status );
		m_Log.SetWindowText(buf);
		m_Log.UpdateWindow();
	}
	else // status < 0 means error situations
	{
		switch ( status )
		{
		case ERROR_WRONG_VE_LENGTH :
			// the length of the requested slice is not accordingly to spec
			m_Log.SetWindowText("ERROR_WRONG_VE_LENGTH");
			m_Log.UpdateWindow();	
			break;

		case ERROR_RX_MESSAGE_TIMEOUT:
			// time out in receiving messages through the sniffer interface
			m_Log.SetWindowText("ERROR_RX_MESSAGE_TIMEOUT");
			m_Log.UpdateWindow();	
			break;

		case ERROR_WRONG_REPLY_LENGTH:
			// the length returned by the REPLY_VALUE message is not the same as the requested length
			m_Log.SetWindowText("ERROR_WRONG_REPLY_LENGTH");
			m_Log.UpdateWindow();	
			break;

		case ERROR_WRONG_MESSAGE:
			// the message received via the sniffer is not the expected sequence of REQUEST_VALUE / REPLY_VALUE
			m_Log.SetWindowText("ERROR_WRONG_MESSAGE");
			m_Log.UpdateWindow();			
			break;
		}
	}


}



